-- BerserKerplosion - by danboo
-- $Id: BerserKerplosion.lua,v 1.2 2004-12-21 21:22:21-05 danboo Exp danboo $

local _event_dispatch = {};
local _debug          = false
local _berserk_spell_id

--
-- Miscellaneous Functions
--

-- display debug info in the chat frame
local function debug(...)
   if not DEFAULT_CHAT_FRAME or not _debug then
      return
   end
   local msg = ''
   for k,v in ipairs(arg) do
      msg = msg .. tostring(v) .. ' : '
   end
   DEFAULT_CHAT_FRAME:AddMessage(msg)
end

-- find the spell ID for 'Berserk(Racial)'
function BerserKerplozion_FindSpellId()

   local i = 1

   while true do

      local spell_name, spell_rank = GetSpellName(i, SpellBookFrame.bookType)

      if not spell_name then
         do break end
      end

      debug(spell_name, spell_rank)

      if spell_name == 'Berserking' and spell_rank == 'Racial' then
         return i
      end

      i = i + 1

   end

end

--
-- Event Handlers
--

_event_dispatch['PLAYER_ENTERING_WORLD'] = function ()

   if UnitRace('player') == 'Troll' then

      this:RegisterEvent("UNIT_HEALTH")
      this:RegisterEvent("UNIT_HEALTHMAX")

      this:SetWidth(WorldFrame:GetWidth())
      this:SetHeight(WorldFrame:GetHeight())

      BerserKerplosionButton:SetWidth(WorldFrame:GetWidth())
      BerserKerplosionButton:SetHeight(WorldFrame:GetHeight())

      _berserk_spell_id = BerserKerplozion_FindSpellId()

      debug('spell id', _berserk_spell_id)

   end

end

_event_dispatch['UNIT_HEALTH'] = function ()

   local unit = arg1

   if unit == 'player' then

      local health     = UnitHealth('player')
      local health_max = UnitHealthMax('player')

      if health > 0 and health_max > 0 and health / health_max < .2 and not UnitIsDeadOrGhost('player') then

         local start, duration, enable = GetSpellCooldown(_berserk_spell_id, SpellBookFrame.bookType)
         debug(start, duration, enable)

         if start == 0 and not this:IsVisible() then
            debug('BerserKerplosion')
            this:Show()
         end

      elseif this:IsVisible() then
         this:Hide()
      end

   end

end

_event_dispatch['UNIT_HEALTH_MAX'] = _event_dispatch['UNIT_HEALTH']

--
-- Game Client Handlers
--

function BerserKerplosion_OnClick(id)

   debug('OnClick', id)

   CastSpell(_berserk_spell_id, SpellBookFrame.bookType)
   BerserKerplosionFrame:Hide()

end

function BerserKerplosion_OnEvent()

   if _event_dispatch[event] then
      debug('OnEvent - yes dispatch', event)
      _event_dispatch[event]()
   else
      debug('OnEvent - no dispatch', event)
   end

end

