DamageWatchVersion = 1.06
--[[

    Damage Watch 
        Author:         Sean Kennedy
        Version:        1.0: Initial release
                        1.01: Subatai - Blocked Viper's Sting or any Mana Drain from inflating the DPS given.
			1.02: Subatai - Removed DPS counting when player does no damage (player is travelling)
			1.03: Subatai-  Changed how Damage Watch deals with Combat Ending
			1.04: Subatai - Added Session DPS Average
			1.05: Subatai - Added the ability to toggle Session and Per Fight DPS on and off
			1.06: Mairelon - Moved saved vars to .toc, updated interface # and version
        ToDo:           Add gui (when time permits
                        Find out if pets cast dots - add in logic for that
        Modified by:    Subatai, Garona
        Last Modified   
	11/14/2004 - Initial version
        11/28/2004 - fixed interface number for retail
	12/04/2004 - fixed useage statement to reflect actual commands
	12/07/2004 - Changed technique for detecting end of combat
	01/20/2005 - Added changes 1.01, 1.02, 1.03, 1.04, and 1.05 listed above.
	02/16/2005 - upgraded to 1.06
]]

-- Configuration variables
    DamageWatchFirstUse = 0;        -- Saved
    DamageWatchEnabled = 0;         -- Saved - 1 = on, 0 = off
    DamageWatchDisplayLoc = "chat"; -- Saved - where to display combat summary
    DamageWatchSession = 0;         -- Saved - 1 = on, 0 = off  v1.05 addition
    DamageWatchPerFight = 0;	    -- Saved - 1 = on, 0 = off  v1.05 addition
-- Local variables
    local mCombatStart = 0;
    local mCombatEnd = 0;
    local mPlayerDamage = 0;
    local mPetDamage = 0;
    local mLastHit = 0;  -- v1.03 addition - How we determine when the last shot was fired in combat.  
    local mTotalCombats = 0; -- v1.04 addition
    local mTotalPlayerDPS = 0; -- v1.04 addition
    local mTotalPetDPS = 0; -- v1.04 addition
    local mDisregard = 1; -- v1.04 addition - to keep the Session DPS monitor from getting confused, when asked for what your last damage output was.
-- OnFoo functions

function DamageWatchOnLoad()
-- respond to saved variable load
	this:RegisterEvent("VARIABLES_LOADED");
	this:RegisterEvent("CHAT_MSG_COMBAT_SELF_HITS"); 
	this:RegisterEvent("CHAT_MSG_COMBAT_PET_HITS"); 
	this:RegisterEvent("CHAT_MSG_SPELL_DAMAGESHIELDS_ON_SELF"); 
	this:RegisterEvent("CHAT_MSG_SPELL_SELF_DAMAGE"); 
	this:RegisterEvent("CHAT_MSG_SPELL_PET_DAMAGE");
	this:RegisterEvent("CHAT_MSG_SPELL_PERIODIC_CREATURE_DAMAGE"); 
--	Poor one to use - only fires leaving MELEE combat
--	this:RegisterEvent("PLAYER_LEAVE_COMBAT");
--  	Much better ones, these reflect gaining and losing aggro.
	this:RegisterEvent("PLAYER_REGEN_DISABLED");
	this:RegisterEvent("PLAYER_REGEN_ENABLED");
end

function DamageWatchOnEvent()
local text;
local firsti;
local lasti;
local value;
    if (event == "VARIABLES_LOADED") then
    -- Saved variables loaded - check for first use and load defaults if necessary
        if (DamageWatchFirstUse == 0) then
            DamageWatchLoadDefaults();
        end
    -- Register for save (moved to .toc)
    -- Register command handler and new commands
		SlashCmdList["DamageWatchCOMMAND"] = DamageWatchSlashHandler;
		SLASH_DamageWatchCOMMAND1 = "/DamageWatch";
		SLASH_DamageWatchCOMMAND2 = "/sdkdw";
    -- Report load
        DamageWatchChatMsg(format("DamageWatch V%.2f Loaded, type /damagewatch for useage",DamageWatchVersion));
    elseif (event == "CHAT_MSG_COMBAT_SELF_HITS") then
        DamageWatchEnterCombat();    
        firsti, lasti, value = string.find(arg1, "(%d+)");
        if (value) then
            mPlayerDamage = mPlayerDamage+value;
	    mLastHit = GetTime(); -- v1.03 Addition  -- Placed in every event except the last 2
        end
    elseif (event == "CHAT_MSG_COMBAT_PET_HITS") then
        DamageWatchEnterCombat();    
        firsti, lasti, value = string.find(arg1, "(%d+)");
        if (value) then
            mPetDamage = mPetDamage + value;
	    mLastHit = GetTime(); -- v1.03 Addition  -- Placed in every event except the last 2
        end
    elseif (event == "CHAT_MSG_SPELL_SELF_DAMAGE") then
        DamageWatchEnterCombat();    
        firsti, lasti, value = string.find(arg1, "(%d+)");
        if ((value) and (not strfind(string.lower(arg1), "mana"))) then  -- V1.01 change to disregard Mana drain.
--        if (value) then  -- Original 1.0 Statement
            mPlayerDamage = mPlayerDamage+value;
	    mLastHit = GetTime(); -- v1.03 Addition  -- Placed in every event except the last 2
        end
    elseif (event == "CHAT_MSG_SPELL_PET_DAMAGE") then
        DamageWatchEnterCombat();    
        firsti, lasti, value = string.find(arg1, "(%d+)");
        if (value) then
            mPetDamage = mPetDamage + value;
	    mLastHit = GetTime(); -- v1.03 Addition  -- Placed in every event except the last 2
        end
    elseif (event == "CHAT_MSG_SPELL_DAMAGESHIELDS_ON_SELF") then
        DamageWatchEnterCombat();    
        firsti, lasti, value = string.find(arg1, "(%d+)");
        if (value) then
            mPlayerDamage = mPlayerDamage+value;
	    mLastHit = GetTime(); -- v1.03 Addition  -- Placed in every event except the last 2
        end
    elseif (event == "CHAT_MSG_SPELL_PERIODIC_CREATURE_DAMAGE") then
        if (strfind(string.lower(arg1), "your")) then
            DamageWatchEnterCombat(); 
            firsti, lasti, value = string.find(arg1, "(%d+)");
            if (value) then
                mPlayerDamage = mPlayerDamage+value;
		mLastHit = GetTime(); -- v1.03 Addition  -- Placed in every event except the last 2
            end
        end
    elseif (event == "PLAYER_REGEN_ENABLED") then
            DamageWatchLeaveCombat();
    elseif (event == "PLAYER_REGEN_DISABLED") then
            DamageWatchEnterCombat();
    end 
end

-- Helper Functions
function DamageWatchSetEnabled(toggle)
    toggle = string.lower(toggle);
    if (toggle == "off") then
        DamageWatchEnabled = 0;
        DamageWatchFloatMsg("Damage Watch Off");
    else
        DamageWatchEnabled = 1;
        DamageWatchFloatMsg("Damage Watch On");
    end        
end

function DamageWatchSetDisplayLoc(loc)
    DamageWatchDisplayLoc = loc;
    DamageWatchFloatMsg("Damage Watch display location: " .. loc);
end

function DamageWatchSlashHandler(msg)
local text = msg;
	msg = string.lower(msg);

-- check for 2 arguments first
	local firsti, lasti, command, value = string.find (msg, "(%w+) (%w+)");
-- if there weren't 2, then command will be nil - check for one arg    
    if (command == nil) then
        firsti, lasti, command = string.find(msg, "(%w+)");
    end    
-- respond to commands
    if (command == nil) then
        DamageWatchDisplayUseage();
    elseif (string.lower(command) == "enable") then
        DamageWatchSetEnabled("on");
    elseif (string.lower(command) == "disable") then
        DamageWatchSetEnabled("off");
    elseif (string.lower(command) == "location") then
        if (value ~= nil) then
            DamageWatchSetDisplayLoc(string.lower(value));
        else
            DamageWatchDisplayUseage();
        end
    elseif (string.lower(command) == "perfight") then  -- v1.05 Addition
        if (string.lower(value) == "enable") then  -- v1.05 Addition
            DamageWatchPerFight = 1;  -- v1.05 Addition
	    DamageWatchChatMsg("Per Fight DPS reporting Enabled");  -- v1.05 Addition
        elseif (string.lower(value) == "disable") then  -- v1.05 Addition
            DamageWatchPerFight = 0;  -- v1.05 Addition
	    DamageWatchChatMsg("Per Fight DPS reporting Disabled");  -- v1.05 Addition
	else  -- v1.05 Addition
            DamageWatchDisplayUseage();  -- v1.05 Addition
        end  -- v1.05 Addition
    elseif (string.lower(command) == "session") then  -- v1.04 Addition
        if (string.lower(value) == "enable") then  -- v1.04 Addition
            DamageWatchSession = 1;  -- v1.04 Addition
	    DamageWatchChatMsg("Session DPS reporting Enabled");  -- v1.04 Addition
        elseif (string.lower(value) == "disable") then  -- v1.04 Addition
            DamageWatchSession = 0;  -- v1.04 Addition
	    DamageWatchChatMsg("Session DPS reporting Disabled");  -- v1.04 Addition
	else  -- v1.04 Addition
            DamageWatchDisplayUseage();  -- v1.04 Addition
        end  -- v1.04 Addition
    elseif (string.lower(command) == "last") then
        mDisregard = 0;  -- v1.04 addition
        DamageWatchLastFight();
    elseif (string.lower(command) == "status") then -- v1.05 addition
        DamageWatchDisplayStatus(); -- v1.05 addition
    elseif (string.lower(command) == "reset") then -- v1.05 addition
		mTotalCombats = 0; -- v1.05 addition
		mTotalPlayerDPS = 0; -- v1.05 addition
		mTotalPetDPS = 0; -- v1.05 addition
		DamageWatchChatMsg("Session DPS data dumped"); -- v1.05 addition
    else
        DamageWatchDisplayUseage();
    end
end

function DamageWatchDisplayStatus()
local text;
    text = "Damage Watch";
    if (DamageWatchEnabled == 1) then
        text = text .. " On";
        if (DamageWatchDisplayLoc == "chat") then
            text = text .. ":Displaying in chat box";
        else
            text = text .. ":Displaying overhead";
        end
        text = text .. "\nSession DPS Reporting is ";
	if (DamageWatchSession == 1) then  -- v1.05 addition
	    text = text .. "Enabled";  -- v1.05 addition
	else  -- v1.05 addition
	    text = text .. "Disabled";  -- v1.05 addition
	end  -- v1.05 addition
        text = text .. ":Per Fight DPS Reporting is ";
	if (DamageWatchPerFight == 1) then  -- v1.05 addition
	    text = text .. "Enabled";  -- v1.05 addition
	else  -- v1.05 addition
	    text = text .. "Disabled";  -- v1.05 addition
	end  -- v1.05 addition
    else
        text = text .. " Off";
    end
    DamageWatchChatMsg(text);
end
function DamageWatchDisplayUseage()
local text;

    text = "Useage: \n/DamageWatch <Enable | Disable | Status | Reset | Last>\n"; -- v1.05 Change
--    text = "Useage: \n/DamageWatch <Enable | Disable | status | reset>\n"; v1.0 Original statement
    text = text .. "/DamageWatch location <chat | overhead>\n";
--    text = text .. "/DamageWatch last\n";  -- v1.04 Deletion.
--    text = text .. "/DamageWatch last";  -- v1.0 Original Statement
    text = text .. "/DamageWatch session <Enable | Disable>\n"; -- v1.04 Addition
    text = text .. "/DamageWatch perfight <Enable | Disable>\n"; -- v1.05 Addition
    DamageWatchChatMsg(text);

end

function DamageWatchChatMsg(msg)
	if( DEFAULT_CHAT_FRAME ) then
		DEFAULT_CHAT_FRAME:AddMessage(msg);
	end
end

function DamageWatchFloatMsg(msg, color)
-- Display overhead message.  7 basic colors available
-- Use at most 3 lines here - the rest get lost
local r, g, b

    if (color == nil) then 
        color = "white";
    end

    if (string.lower(color) == "red") then
        r, g, b = 1.0, 0.0, 0.0;
    elseif (string.lower(color) == "green") then
        r, g, b = 0.0, 1.0, 0.0;
    elseif (string.lower(color) == "blue") then
        r, g, b = 0.0, 0.0, 1.0;
    elseif (string.lower(color) == "magenta") then
        r, g, b = 1.0, 0.0, 1.0;
    elseif (string.lower(color) == "yellow") then
        r, g, b = 1.0, 1.0, 0.0;
    elseif (string.lower(color) == "cyan") then
        r, g, b = 0.0, 1.0, 1.0;
    else 
        r, g, b = 1.0, 1.0, 1.0;
    end

	UIErrorsFrame:AddMessage(msg, r, g, b, 1.0, UIERRORS_HOLD_TIME);
    
end

function DamageWatchLoadDefaults()
local text;
    DamageWatchFirstUse = 1;        
    DamageWatchEnabled = 1;         
    DamageWatchDisplayLoc = "chat";
    DamageWatchSession = 1; -- v1.05 Addition
    DamageWatchPerFight = 1; -- v1.05 Addition

    text = "DamageWatch loading defaults\n";
    text = text .. "type /DamageWatch for commands\n"

    DamageWatchChatMsg(text);
end

function DamageWatchEnterCombat()
    if (not mInCombat) then
        mInCombat = 1;
        mPlayerDamage = 0;
        mPetDamage = 0;
        mCombatStart = GetTime();
    end
end

function DamageWatchLeaveCombat()
local duration
local petdps
local playerdps
local playertext = "%.1f sec. | %d damage | %.1f DPS";
local pettext = "Pet - %d damage | %.1f DPS";
local text;
    mCombatEnd = mLastHit;  -- v1.03 change
    mCombatEnd = GetTime(); -- Original 1.0 statement.
    mInCombat = nil;
    if (mPlayerDamage > 0) then  -- v1.02 addition
        DamageWatchLastFight();
    end  -- v1.02 addition

end

function DamageWatchLastFight()
local duration
local petdps
local playerdps
local sPlayerDPS  -- v1.04 Addition
local sPetDPS  -- v1.04 Addition
local playertext = "%.1f sec. | %d damage | %.1f DPS";
local pettext = "Pet - %d damage | %.1f DPS";
local sessiontext = "DPS Average over %d fights: %.1f DPS Player | %.1f DPS Pet";  -- v1.04 Addition
local text;

    if ((not mInCombat) and (mCombatEnd > mCombatStart)) then
        duration = mCombatEnd - mCombatStart;
        petdps = mPetDamage / duration;
        playerdps = mPlayerDamage / duration;
       if (mDisregard ~= 0) then -- v1.04 Addition
	    mTotalCombats = mTotalCombats+1; -- v1.04 Addition
            mTotalPlayerDPS = mTotalPlayerDPS + playerdps;   -- v1.04 Addition
	    mTotalPetDPS = mTotalPetDPS + petdps;  -- v1.04 Addition
        end -- v1.04 Addition
        sPlayerDPS = mTotalPlayerDPS / mTotalCombats;   -- v1.04 Addition
        sPetDPS =  mTotalPetDPS / mTotalCombats;   -- v1.04 Addition
        text = "";
	if (DamageWatchPerFight ~= 0) then --v1.05 Addition
	    text = text .. format(playertext, duration, mPlayerDamage, playerdps);
	    if (mPetDamage ~= 0) then
	        text = text .. "\n";
	        text = text .. format(pettext, mPetDamage, petdps);
	    end
        end --v1.05 Addition
        if (DamageWatchSession ~= 0) then --v1.05 Addition
            if (DamageWatchPerFight ~= 0) then --v1.05 Addition
	        text = text .. "\n"; -- v1.04 Addition
	    end --v1.05 Addition
            text = text .. format(sessiontext, mTotalCombats, sPlayerDPS, sPetDPS); -- v1.04 Addition
        end  --v1.05 addition
        if (DamageWatchEnabled ~= 0) then
            if (DamageWatchDisplayLoc == "chat") then
                DamageWatchChatMsg(text);
            else
                DamageWatchFloatMsg(text);
            end
        end
	mDisregard = 1; -- v1.04 Addition
    end
end