--[[

	Insomniax Latency Display v1.0
	by LedMirage, http://www.insomniax.net
	01/24/2005
	
	Tweaks made to Svarten's original LatencyDisplay mod to make moving the frame easier and to make it
	say Latency instead of LAG, full credit of the code goes to Svarten, the renaming of the mod is 
	simply to avoid version confusion.

	- Displays the in-game latency in text within a moveable frame.

]]


function LD_OnLoad()
	if(ChatFrame2) then
		ChatFrame2:AddMessage("|cff748BFFInsomniax Latency Display v1.0 Loaded|r");
	else
		if ( DEFAULT_CHAT_FRAME ) then 
			DEFAULT_CHAT_FRAME:AddMessage("|cff748BFFInsomniax Latency Display v1.0 Loaded|r");
		end
	end

end

function LD_OnUpdate(arg1)
	local bandwidthIn, bandwidthOut, latency = GetNetStats();
	LD_Text:SetVertexColor(0.3, 0.9, 0.3);
	
	if (latency > PERFORMANCEBAR_MEDIUM_LATENCY) then
		LD_Text:SetVertexColor(0.9, 0.3, 0.3);
	elseif (latency > PERFORMANCEBAR_LOW_LATENCY) then
		LD_Text:SetVertexColor(1.0, 0.85, 0);
	else
		LD_Text:SetVertexColor(0.3, 0.9, 0.3);
	end

	LD_Text:SetText("Latency: "..(latency).." ms.");

end
